diff --git a/modules/PowerManagement_1-1/module.c b/modules/PowerManagement_1-1/module.c
index eae82ee..2c0146b 100644
--- a/modules/PowerManagement_1-1/module.c
+++ b/modules/PowerManagement_1-1/module.c
@@ -29,14 +29,11 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /**
  * @brief   Interrupt service routine callback for I/O interrupt signals.
  *
- * @param   extp      EXT driver to handle the ISR.
- * @param   channel   Channel on which the interrupt was encountered.
+ * @param   args      Channel on which the interrupt was encountered.
  */
-static void _moduleIsrCallback(EXTDriver* extp, expchannel_t channel) {
-  (void)extp;
-
+static void _modulePalIsrCallback(void *args) {
   chSysLockFromISR();
-  chEvtBroadcastFlagsI(&aos.events.io, (1 << channel));
+  chEvtBroadcastFlagsI(&aos.events.io, (1 << (*(uint16_t*)args)));
   chSysUnlockFromISR();
 
   return;
@@ -72,101 +69,124 @@ CANConfig moduleHalCanConfig = {
   /* btr  */ CAN_BTR_SJW(1) | CAN_BTR_TS2(3) | CAN_BTR_TS1(15) | CAN_BTR_BRP(1),
 };
 
-EXTConfig moduleHalExtConfig = {
-  /* channel configrations */ {
-    /* channel  0 */ { // IR_INT1_N: must be enabled explicitely
-      /* mode     */ EXT_MODE_GPIOB | APAL2CH_EDGE(VCNL4020_LLD_INT_EDGE),
-      /* callback */ _moduleIsrCallback,
-    },
-    /* channel  1 */ { // GAUGE_BATLOW1: must be enabled explicitely
-      /* mode     */ EXT_MODE_GPIOC | EXT_CH_MODE_RISING_EDGE,
-      /* callback */ _moduleIsrCallback,
-    },
-    /* channel  2 */ { // GAUGE_BATDG1_N: must be enabled expliciety
-      /* mode     */ EXT_MODE_GPIOC | EXT_CH_MODE_RISING_EDGE,
-      /* callback */ _moduleIsrCallback,
-    },
-    /* channel  3 */ { // SYS_UART_DN: automatic interrupt on event
-      /* mode     */ EXT_MODE_GPIOB | EXT_CH_MODE_BOTH_EDGES | EXT_CH_MODE_AUTOSTART,
-      /* callback */ _moduleIsrCallback,
-    },
-    /* channel  4 */ { // IR_INT2_N: must be enabled explicitely
-      /* mode     */ EXT_MODE_GPIOC | APAL2CH_EDGE(VCNL4020_LLD_INT_EDGE),
-      /* callback */ _moduleIsrCallback,
-    },
-    /* channel  5 */ { // TOUCH_INT: must be enabled explicitely
-      /* mode     */ EXT_MODE_GPIOC | APAL2CH_EDGE(MPR121_LLD_INT_EDGE),
-      /* callback */ _moduleIsrCallback,
-    },
-    /* channel  6 */ { // GAUGE_BATLOW2: must be enabled explicitely
-      /* mode     */ EXT_MODE_GPIOB | EXT_CH_MODE_RISING_EDGE,
-      /* callback */ _moduleIsrCallback,
+aos_interrupt_cfg_t moduleIntConfig[14] = {
+    /* channel  1 */ { // IR_INT1_N: must be enabled explicitely
+      /* port     */ GPIOB,
+      /* pad      */ GPIOB_IR_INT1_N,
+      /* flags    */ 0,
+      /* mode     */ APAL2CH_EDGE(VCNL4020_LLD_INT_EDGE),
+      /* callback */ _modulePalIsrCallback,
+      /* cb arg   */ 1,
     },
-    /* channel  7 */ { // GAUGE_BATDG2_N: must be enabled expliciety
-      /* mode     */ EXT_MODE_GPIOB | EXT_CH_MODE_RISING_EDGE,
-      /* callback */ _moduleIsrCallback,
+    /* channel  2 */ { // GAUGE_BATLOW1: must be enabled explicitely
+      /* port     */ GPIOC,
+      /* pad      */ GPIOC_GAUGE_BATLOW1,
+      /* flags    */ 0,
+      /* mode     */ PAL_EVENT_MODE_RISING_EDGE,
+      /* callback */ _modulePalIsrCallback,
+      /* cb arg   */ 2,
     },
-    /* channel  8 */ { // PATH_DC: must be enabled explicitely
-      /* mode     */ EXT_MODE_GPIOC | EXT_CH_MODE_BOTH_EDGES,
-      /* callback */ _moduleIsrCallback,
+    /* channel  3 */ { // GAUGE_BATGD1_N: must be enabled explicitely
+      /* port     */ GPIOC,
+      /* pad      */ GPIOC_GAUGE_BATGD1_N,
+      /* flags    */ 0,
+      /* mode     */ PAL_EVENT_MODE_RISING_EDGE,
+      /* callback */ _modulePalIsrCallback,
+      /* cb arg   */ 3,
     },
-    /* channel  9 */ { // SYS_SPI_DIR: must be enabled explicitely
-      /* mode     */ EXT_MODE_GPIOC | EXT_CH_MODE_BOTH_EDGES,
-      /* callback */ _moduleIsrCallback,
+    /* channel  4 */ { // SYS_UART_DN: automatic interrupt on event
+      /* port     */ GPIOB,
+      /* pad      */ GPIOB_SYS_UART_DN,
+      /* flags    */ AOS_INTERRUPT_AUTOSTART,
+      /* mode     */ PAL_EVENT_MODE_BOTH_EDGES,
+      /* callback */ _modulePalIsrCallback,
+      /* cb arg   */ 4,
     },
-    /* channel 10 */ {
-      /* mode     */ EXT_CH_MODE_DISABLED,
-      /* callback */ NULL,
+    /* channel  5 */ { // IR_INT2_N: must be enabled explicitely
+      /* port     */ GPIOC,
+      /* pad      */ GPIOC_IR_INT2_N,
+      /* flags    */ 0,
+      /* mode     */ APAL2CH_EDGE(VCNL4020_LLD_INT_EDGE),
+      /* callback */ _modulePalIsrCallback,
+      /* cb arg   */ 5,
     },
-    /* channel 11 */ {
-      /* mode     */ EXT_CH_MODE_DISABLED,
-      /* callback */ NULL,
+    /* channel  6 */ { // TOUCH_INT: must be enabled explicitely
+      /* port     */ GPIOC,
+      /* pad      */ GPIOC_TOUCH_INT_N,
+      /* flags    */ 0,
+      /* mode     */ APAL2CH_EDGE(MPR121_LLD_INT_EDGE),
+      /* callback */ _modulePalIsrCallback,
+      /* cb arg   */ 6,
     },
-    /* channel 12 */ { // SYS_SYNC_N: automatic interrupt on event
-      /* mode     */ EXT_MODE_GPIOC | EXT_CH_MODE_BOTH_EDGES | EXT_CH_MODE_AUTOSTART,
-      /* callback */ _moduleIsrCallback,
+    /* channel  7 */ { // GAUGE_BATLOW2: must be enabled explicitely
+      /* port     */ GPIOB,
+      /* pad      */ GPIOB_GAUGE_BATLOW2,
+      /* flags    */ 0,
+      /* mode     */ PAL_EVENT_MODE_RISING_EDGE,
+      /* callback */ _modulePalIsrCallback,
+      /* cb arg   */ 7,
     },
-    /* channel 13 */ { // SYS_PD_N: automatic interrupt when activated
-      /* mode     */ EXT_MODE_GPIOC | EXT_CH_MODE_FALLING_EDGE | EXT_CH_MODE_AUTOSTART,
-      /* callback */ _moduleIsrCallback,
+    /* channel  8 */ { // GAUGE_BATGD2_N: must be enabled explicitely
+      /* port     */ GPIOB,
+      /* pad      */ GPIOB_GAUGE_BATGD2_N,
+      /* flags    */ 0,
+      /* mode     */ PAL_EVENT_MODE_RISING_EDGE,
+      /* callback */ _modulePalIsrCallback,
+      /* cb arg   */ 8,
     },
-    /* channel 14 */ { // SYS_WARMRST_N: automatic interrupt when activated
-      /* mode     */ EXT_MODE_GPIOC | EXT_CH_MODE_FALLING_EDGE | EXT_CH_MODE_AUTOSTART,
-      /* callback */ _moduleIsrCallback,
+    /* channel  9 */ { // PATH_DC: must be enabled explicitely
+      /* port     */ GPIOC,
+      /* pad      */ GPIOC_PATH_DC,
+      /* flags    */ 0,
+      /* mode     */ PAL_EVENT_MODE_BOTH_EDGES,
+      /* callback */ _modulePalIsrCallback,
+      /* cb arg   */ 9,
     },
-    /* channel 15 */ { // SYS_UART_UP: automatic interrupt on event
-      /* mode     */ EXT_MODE_GPIOB| EXT_CH_MODE_BOTH_EDGES | EXT_CH_MODE_AUTOSTART,
-      /* callback */ _moduleIsrCallback,
+    /* channel 10 */ { // SYS_SPI_DIR: must be enabled explicitely
+      /* port     */ GPIOC,
+      /* pad      */ GPIOC_SYS_SPI_DIR,
+      /* flags    */ 0,
+      /* mode     */ PAL_EVENT_MODE_BOTH_EDGES,
+      /* callback */ _modulePalIsrCallback,
+      /* cb arg   */ 10,
     },
-    /* channel 16 */ {
-      /* mode     */ EXT_CH_MODE_DISABLED,
-      /* callback */ NULL,
+    /* channel 11 */ { // SYS_SYNC_N: must be enabled explicitely
+      /* port     */ GPIOC,
+      /* pad      */ GPIOC_SYS_INT_N, // TODO: check this
+      /* flags    */ AOS_INTERRUPT_AUTOSTART,
+      /* mode     */ PAL_EVENT_MODE_BOTH_EDGES,
+      /* callback */ _modulePalIsrCallback,
+      /* cb arg   */ 11,
     },
-    /* channel 17 */ {
-      /* mode     */ EXT_CH_MODE_DISABLED,
-      /* callback */ NULL,
+    /* channel 12 */ { // SYS_PD_N: must be enabled explicitely
+      /* port     */ GPIOC,
+      /* pad      */ GPIOC_SYS_PD_N,
+      /* flags    */ AOS_INTERRUPT_AUTOSTART,
+      /* mode     */ PAL_EVENT_MODE_FALLING_EDGE,
+      /* callback */ _modulePalIsrCallback,
+      /* cb arg   */ 12,
     },
-    /* channel 18 */ {
-      /* mode     */ EXT_CH_MODE_DISABLED,
-      /* callback */ NULL,
+    /* channel 13 */ { // SYS_WARMRST_N: must be enabled explicitely
+      /* port     */ GPIOC,
+      /* pad      */ GPIOC_SYS_WARMRST_N,
+      /* flags    */ AOS_INTERRUPT_AUTOSTART,
+      /* mode     */ PAL_EVENT_MODE_FALLING_EDGE,
+      /* callback */ _modulePalIsrCallback,
+      /* cb arg   */ 13,
     },
-    /* channel 19 */ {
-      /* mode     */ EXT_CH_MODE_DISABLED,
-      /* callback */ NULL,
+    /* channel 14 */ { // SYS_UART_UP: must be enabled explicitely
+      /* port     */ GPIOB,
+      /* pad      */ GPIOB_SYS_UART_UP,
+      /* flags    */ AOS_INTERRUPT_AUTOSTART,
+      /* mode     */ PAL_EVENT_MODE_BOTH_EDGES,
+      /* callback */ _modulePalIsrCallback,
+      /* cb arg   */ 14,
     },
-    /* channel 20 */ {
-      /* mode     */ EXT_CH_MODE_DISABLED,
-      /* callback */ NULL,
-    },
-    /* channel 21 */ {
-      /* mode     */ EXT_CH_MODE_DISABLED,
-      /* callback */ NULL,
-    },
-    /* channel 22 */ {
-      /* mode     */ EXT_CH_MODE_DISABLED,
-      /* callback */ NULL,
-    },
-  },
+};
+
+aos_interrupt_driver_t moduleIntDriver = {
+  /* config     */ NULL,
+  /* interrupts */ 14,
 };
 
 I2CConfig moduleHalI2cProxPm18Pm33GaugeRearConfig = {
@@ -879,15 +899,16 @@ static int _utShellCmdCb_AlldMpr121(BaseSequentialStream* stream, int argc, char
 {
   (void)argc;
   (void)argv;
-  extChannelEnable(&MODULE_HAL_EXT, MODULE_GPIO_EXTCHANNEL_TOUCHINT);
+  aosIntEnable(&moduleIntDriver, MODULE_GPIO_INT_TOUCHINT);
   aosUtRun(stream, &moduleUtAlldMpr121, NULL);
+  aosIntDisable(&moduleIntDriver, MODULE_GPIO_INT_TOUCHINT);
   return AOS_OK;
 }
 static ut_mpr121data_t _utAlldMpr121Data= {
   /* MPR121 driver  */ &moduleLldTouch,
   /* timeout        */ MICROSECONDS_PER_SECOND,
   /* event source   */ &aos.events.io,
-  /* event flags    */ (1 << MODULE_GPIO_EXTCHANNEL_TOUCHINT),
+  /* event flags    */ (1 << MODULE_GPIO_INT_TOUCHINT),
 };
 aos_unittest_t moduleUtAlldMpr121 = {
   /* name           */ "MPR121",
@@ -1061,8 +1082,8 @@ static int _utShellCmdCb_AlldVcnl4020(BaseSequentialStream* stream, int argc, ch
       case WNW:
         mux = &moduleLldI2cMultiplexer1;
         ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->vcnld = &moduleLldProximity1;
-        ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->evtflags = (1 << MODULE_GPIO_EXTCHANNEL_IRINT2);
-        extChannelEnable(&MODULE_HAL_EXT, MODULE_GPIO_EXTCHANNEL_IRINT2);
+        ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->evtflags = (1 << MODULE_GPIO_INT_IRINT2);
+        aosIntEnable(&moduleIntDriver, MODULE_GPIO_INT_IRINT2);
         break;
       case NNW:
       case NNE:
@@ -1070,8 +1091,8 @@ static int _utShellCmdCb_AlldVcnl4020(BaseSequentialStream* stream, int argc, ch
       case ESE:
         mux = &moduleLldI2cMultiplexer2;
         ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->vcnld = &moduleLldProximity2;
-        ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->evtflags = (1 << MODULE_GPIO_EXTCHANNEL_IRINT1);
-        extChannelEnable(&MODULE_HAL_EXT, MODULE_GPIO_EXTCHANNEL_IRINT1);
+        ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->evtflags = (1 << MODULE_GPIO_INT_IRINT1);
+        aosIntEnable(&moduleIntDriver, MODULE_GPIO_INT_IRINT1);
         break;
       default:
         break;
@@ -1088,34 +1109,42 @@ static int _utShellCmdCb_AlldVcnl4020(BaseSequentialStream* stream, int argc, ch
       case NNE:
         pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH1, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
         aosUtRun(stream, &moduleUtAlldVcnl4020, "north-northeast sensor");
+        aosIntDisable(&moduleIntDriver, MODULE_GPIO_INT_IRINT1);
         break;
       case ENE:
         pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH3, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
         aosUtRun(stream, &moduleUtAlldVcnl4020, "east-northeast sensor");
+        aosIntDisable(&moduleIntDriver, MODULE_GPIO_INT_IRINT1);
         break;
       case ESE:
         pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH2, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
         aosUtRun(stream, &moduleUtAlldVcnl4020, "north-southeast sensor");
+        aosIntDisable(&moduleIntDriver, MODULE_GPIO_INT_IRINT1);
         break;
       case SSE:
         pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH0, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
         aosUtRun(stream, &moduleUtAlldVcnl4020, "south-southeast sensor");
+        aosIntDisable(&moduleIntDriver, MODULE_GPIO_INT_IRINT2);
         break;
       case SSW:
         pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH1, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
         aosUtRun(stream, &moduleUtAlldVcnl4020, "south-southwest sensor");
+        aosIntDisable(&moduleIntDriver, MODULE_GPIO_INT_IRINT2);
         break;
       case WSW:
         pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH3, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
         aosUtRun(stream, &moduleUtAlldVcnl4020, "west-southwest sensor");
+        aosIntDisable(&moduleIntDriver, MODULE_GPIO_INT_IRINT2);
         break;
       case WNW:
         pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH2, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
         aosUtRun(stream, &moduleUtAlldVcnl4020, "west-northwest sensor");
+        aosIntDisable(&moduleIntDriver, MODULE_GPIO_INT_IRINT2);
         break;
       case NNW:
         pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH0, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
         aosUtRun(stream, &moduleUtAlldVcnl4020, "north-northwest sensor");
+        aosIntDisable(&moduleIntDriver, MODULE_GPIO_INT_IRINT1);
         break;
       default:
         break;
diff --git a/modules/PowerManagement_1-1/module.h b/modules/PowerManagement_1-1/module.h
index 2f54e73..6716029 100644
--- a/modules/PowerManagement_1-1/module.h
+++ b/modules/PowerManagement_1-1/module.h
@@ -62,6 +62,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 /*===========================================================================*/
 #include <hal.h>
+#include <aos_interrupts.h>
 
 /**
  * @brief   ADC driver for reading the system voltage.
@@ -84,14 +85,15 @@ extern ADCConversionGroup moduleHalAdcVsysConversionGroup;
 extern CANConfig moduleHalCanConfig;
 
 /**
- * @brief   Interrupt driver to use.
+ * @brief   Interrupt driver (PAL).
  */
-#define MODULE_HAL_EXT                          EXTD1
+
+extern aos_interrupt_driver_t moduleIntDriver;
 
 /**
- * @brief   Interrupt driver configuration.
+ * @brief   Interrupt driver config.
  */
-extern EXTConfig moduleHalExtConfig;
+extern aos_interrupt_cfg_t moduleIntConfig[14];
 
 /**
  * @brief   I2C driver to access multiplexer, proximity sensors 1 to 4, power monitors for VIO1.8 and VIO 3.3, and fuel gauge (rear battery).
@@ -156,72 +158,72 @@ extern SerialConfig moduleHalProgIfConfig;
 /**
  * @brief   Interrupt channel for the IR_INT1 and CHARGE_STAT1A signals.
  */
-#define MODULE_GPIO_EXTCHANNEL_IRINT1           ((expchannel_t)0)
+#define MODULE_GPIO_INT_IRINT1           ((uint8_t)1)
 
 /**
  * @brief   Interrupt channel for the GAUGE_BATLOW1 signal.
  */
-#define MODULE_GPIO_EXTCHANNEL_GAUGEBATLOW1     ((expchannel_t)1)
+#define MODULE_GPIO_INT_GAUGEBATLOW1     ((uint8_t)2)
 
 /**
  * @brief   Interrupt channel for the GAUGE_BATGD1 signal.
  */
-#define MODULE_GPIO_EXTCHANNEL_GAUGEBATGD1      ((expchannel_t)2)
+#define MODULE_GPIO_INT_GAUGEBATGD1      ((uint8_t)3)
 
 /**
  * @brief   Interrupt channel for the SYS_UART_DN signal.
  */
-#define MODULE_GPIO_EXTCHANNEL_SYSUARTDN        ((expchannel_t)3)
+#define MODULE_GPIO_INT_SYSUARTDN        ((uint8_t)4)
 
 /**
  * @brief   Interrupt channel for the IR_INT2 and CHARGE_STAT2A signals.
  */
-#define MODULE_GPIO_EXTCHANNEL_IRINT2           ((expchannel_t)4)
+#define MODULE_GPIO_INT_IRINT2           ((uint8_t)5)
 
 /**
  * @brief   Interrupt channel for the TOUCH_INT signal.
  */
-#define MODULE_GPIO_EXTCHANNEL_TOUCHINT         ((expchannel_t)5)
+#define MODULE_GPIO_INT_TOUCHINT         ((uint8_t)6)
 
 /**
  * @brief   Interrupt channel for the GAUGE_BATLOW2 signal.
  */
-#define MODULE_GPIO_EXTCHANNEL_GAUGEBATLOW2     ((expchannel_t)6)
+#define MODULE_GPIO_INT_GAUGEBATLOW2     ((uint8_t)7)
 
 /**
  * @brief   Interrupt channel for the GAUGE_BATGD2 signal.
  */
-#define MODULE_GPIO_EXTCHANNEL_GAUGEBATGD2      ((expchannel_t)7)
+#define MODULE_GPIO_INT_GAUGEBATGD2      ((uint8_t)8)
 
 /**
  * @brief   Interrupt channel for the PATH_DC signal.
  */
-#define MODULE_GPIO_EXTCHANNEL_PATHDC           ((expchannel_t)8)
+#define MODULE_GPIO_INT_PATHDC           ((uint8_t)9)
 
 /**
  * @brief   Interrupt channel for the SYS_SPI_DIR signal.
  */
-#define MODULE_GPIO_EXTCHANNEL_SYSSPIDIR        ((expchannel_t)9)
+#define MODULE_GPIO_INT_SYSSPIDIR        ((uint8_t)10)
 
 /**
  * @brief   Interrupt channel for the SYS_SYNC signal.
  */
-#define MODULE_GPIO_EXTCHANNEL_SYSSYNC          ((expchannel_t)12)
+#define MODULE_GPIO_INT_SYSSYNC          ((uint8_t)11)
 
 /**
  * @brief   Interrupt channel for the SYS_PD signal.
  */
-#define MODULE_GPIO_EXTCHANNEL_SYSPD            ((expchannel_t)13)
+#define MODULE_GPIO_INT_SYSPD            ((uint8_t)12)
 
 /**
  * @brief   Interrupt channel for the SYS_WARMRST signal.
  */
-#define MODULE_GPIO_EXTCHANNEL_SYSWARMRST       ((expchannel_t)14)
+#define MODULE_GPIO_INT_SYSWARMRST       ((uint8_t)13)
 
 /**
  * @brief   Interrupt channel for the SYS_UART_UP signal.
  */
-#define MODULE_GPIO_EXTCHANNEL_SYSUARTUP        ((expchannel_t)15)
+#define MODULE_GPIO_INT_SYSUARTUP        ((uint8_t)14)
 
 /**
  * @brief   SYS_REG_EN output signal GPIO.
@@ -355,72 +357,72 @@ extern apalGpio_t moduleGpioChargeEn2;
 /**
  * @brief   Event flag to be set on a IR_INT1 / CHARGE_STAT1A interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_IRINT1           ((eventflags_t)1 << MODULE_GPIO_EXTCHANNEL_IRINT1)
+#define MODULE_OS_IOEVENTFLAGS_IRINT1           ((eventflags_t)1 << MODULE_GPIO_INT_IRINT1)
 
 /**
  * @brief   Event flag to be set on a GAUGE_BATLOW1 interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_GAUGEBATLOW1     ((eventflags_t)1 << MODULE_GPIO_EXTCHANNEL_GAUGEBATLOW1)
+#define MODULE_OS_IOEVENTFLAGS_GAUGEBATLOW1     ((eventflags_t)1 << MODULE_GPIO_INT_GAUGEBATLOW1)
 
 /**
  * @brief   Event flag to be set on a GAUGE_BATGD1 interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_GAUGEBATGD1      ((eventflags_t)1 << MODULE_GPIO_EXTCHANNEL_GAUGEBATGD1)
+#define MODULE_OS_IOEVENTFLAGS_GAUGEBATGD1      ((eventflags_t)1 << MODULE_GPIO_INT_GAUGEBATGD1)
 
 /**
  * @brief   Event flag to be set on a SYS_UART_DN interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSUARTDN        ((eventflags_t)1 << MODULE_GPIO_EXTCHANNEL_SYSUARTDN)
+#define MODULE_OS_IOEVENTFLAGS_SYSUARTDN        ((eventflags_t)1 << MODULE_GPIO_INT_SYSUARTDN)
 
 /**
  * @brief   Event flag to be set on a IR_INT2 / CHARGE_STAT2A interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_IRINT2           ((eventflags_t)1 << MODULE_GPIO_EXTCHANNEL_IRINT2)
+#define MODULE_OS_IOEVENTFLAGS_IRINT2           ((eventflags_t)1 << MODULE_GPIO_INT_IRINT2)
 
 /**
  * @brief   Event flag to be set on a TOUCH_INT interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_TOUCHINT         ((eventflags_t)1 << MODULE_GPIO_EXTCHANNEL_TOUCHINT)
+#define MODULE_OS_IOEVENTFLAGS_TOUCHINT         ((eventflags_t)1 << MODULE_GPIO_INT_TOUCHINT)
 
 /**
  * @brief   Event flag to be set on a GAUGE_BATLOW2 interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_GAUGEBATLOW2     ((eventflags_t)1 << MODULE_GPIO_EXTCHANNEL_GAUGEBATLOW2)
+#define MODULE_OS_IOEVENTFLAGS_GAUGEBATLOW2     ((eventflags_t)1 << MODULE_GPIO_INT_GAUGEBATLOW2)
 
 /**
  * @brief   Event flag to be set on a GAUGE_BATGD2 interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_GAUGEBATGD2      ((eventflags_t)1 << MODULE_GPIO_EXTCHANNEL_GAUGEBATGD2)
+#define MODULE_OS_IOEVENTFLAGS_GAUGEBATGD2      ((eventflags_t)1 << MODULE_GPIO_INT_GAUGEBATGD2)
 
 /**
  * @brief   Event flag to be set on a PATH_DC interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_PATHDC           ((eventflags_t)1 << MODULE_GPIO_EXTCHANNEL_PATHDC)
+#define MODULE_OS_IOEVENTFLAGS_PATHDC           ((eventflags_t)1 << MODULE_GPIO_INT_PATHDC)
 
 /**
  * @brief   Event flag to be set on a SYS_SPI_DIR interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSSPIDIR        ((eventflags_t)1 << MODULE_GPIO_EXTCHANNEL_SYSSPIDIR)
+#define MODULE_OS_IOEVENTFLAGS_SYSSPIDIR        ((eventflags_t)1 << MODULE_GPIO_INT_SYSSPIDIR)
 
 /**
  * @brief   Event flag to be set on a SYS_SYNC interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSSYNC          ((eventflags_t)1 << MODULE_GPIO_EXTCHANNEL_SYSSYNC)
+#define MODULE_OS_IOEVENTFLAGS_SYSSYNC          ((eventflags_t)1 << MODULE_GPIO_INT_SYSSYNC)
 
 /**
  * @brief   Event flag to be set on a SYS_PD interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSPD            ((eventflags_t)1 << MODULE_GPIO_EXTCHANNEL_SYSPD)
+#define MODULE_OS_IOEVENTFLAGS_SYSPD            ((eventflags_t)1 << MODULE_GPIO_INT_SYSPD)
 
 /**
  * @brief   Event flag to be set on a SYS_WARMRST interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSWARMRST       ((eventflags_t)1 << MODULE_GPIO_EXTCHANNEL_SYSWARMRST)
+#define MODULE_OS_IOEVENTFLAGS_SYSWARMRST       ((eventflags_t)1 << MODULE_GPIO_INT_SYSWARMRST)
 
 /**
  * @brief   Event flag to be set on a SYS_UART_UP interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSUARTUP        ((eventflags_t)1 << MODULE_GPIO_EXTCHANNEL_SYSUARTUP)
+#define MODULE_OS_IOEVENTFLAGS_SYSUARTUP        ((eventflags_t)1 << MODULE_GPIO_INT_SYSUARTUP)
 
 #if (AMIROOS_CFG_SHELL_ENABLE == true) || defined(__DOXYGEN__)
 /**
diff --git a/os/core/core.mk b/os/core/core.mk
index 9bc01a8..ea94bd8 100644
--- a/os/core/core.mk
+++ b/os/core/core.mk
@@ -37,7 +37,8 @@ AMIROOSCORECSRC = $(AMIROOS_CORE_DIR)src/aos_debug.c \
                   $(AMIROOS_CORE_DIR)src/aos_thread.c \
                   $(AMIROOS_CORE_DIR)src/aos_time.c \
                   $(AMIROOS_CORE_DIR)src/aos_timer.c \
-                  $(AMIROOS_CORE_DIR)src/aos_unittest.c
+                  $(AMIROOS_CORE_DIR)src/aos_unittest.c \
+                  $(AMIROOS_CORE_DIR)src/aos_interrupts.c \
 
 # C++ source files
 AMIROOSCORECPPSRC = $(AMIROOS_CORE_DIR)src/aos_main.cpp
diff --git a/os/core/inc/aos_interrupts.h b/os/core/inc/aos_interrupts.h
new file mode 100644
index 0000000..cd5075c
--- /dev/null
+++ b/os/core/inc/aos_interrupts.h
@@ -0,0 +1,61 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2018  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY) without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/.
+*/
+
+#ifndef _AMIROOS_INTERRUPTS_H_
+#define _AMIROOS_INTERRUPTS_H_
+
+#include <hal.h>
+
+/**
+ * @brief   Interrupt configuration flag to autostart the interrupt when the interrupt system is started.
+ */
+#define AOS_INTERRUPT_AUTOSTART 0x1u
+
+/**
+ * @brief   Interrupt configuration structure.
+ */
+typedef struct {
+  ioportid_t    port;      /**< Gpio port id. */
+  uint8_t       pad;       /**< Gpio pad.     */
+  uint8_t       flags;     /**< Interrupt configuration flags. */
+  uint8_t       eventmode; /**< Pal event mode. */
+  palcallback_t cb;        /**< Pal callback function. */
+  uint8_t       cb_arg;    /**< Argument for the callback function. */
+} aos_interrupt_cfg_t;
+
+/**
+ * @brief   Interrupt driver structure.
+ */
+typedef struct {
+  aos_interrupt_cfg_t *interrupts; /**< Array of interrupt configurations. */
+  uint8_t len;                     /**< Length of the interrupt configuration array. */
+} aos_interrupt_driver_t;
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+  void aosIntDriverInit(aos_interrupt_driver_t *intd, aos_interrupt_cfg_t *interrupt_cfg);
+  void aosIntDriverStart(aos_interrupt_driver_t *intd);
+  void aosIntDriverStop(aos_interrupt_driver_t *intd);
+  void aosIntEnable(aos_interrupt_driver_t *intd, uint8_t channel);
+  void aosIntDisable(aos_interrupt_driver_t *intd, uint8_t channel);
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* _AMIROOS_INTERRUPTS_H_ */
diff --git a/os/core/inc/aos_system.h b/os/core/inc/aos_system.h
index bfb4806..f229939 100644
--- a/os/core/inc/aos_system.h
+++ b/os/core/inc/aos_system.h
@@ -23,6 +23,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #include <amiro-lld.h>
 #include <aos_shell.h>
 #include <aos_time.h>
+#include <aos_interrupts.h>
 #include <chprintf.h>
 
 /**
@@ -190,7 +191,7 @@ extern "C" {
   void aosSysShutdownInit(aos_shutdown_t shutdown);
   void aosSysStop(void);
   void aosSysDeinit(void);
-  void aosSysShutdownFinal(EXTDriver* extDrv, aos_shutdown_t shutdown);
+  void aosSysShutdownFinal(aos_interrupt_driver_t* intDrv, aos_shutdown_t shutdown);
 #ifdef __cplusplus
 }
 #endif
diff --git a/os/core/inc/aos_thread.h b/os/core/inc/aos_thread.h
index 3ecf8f4..1f369c8 100644
--- a/os/core/inc/aos_thread.h
+++ b/os/core/inc/aos_thread.h
@@ -70,22 +70,22 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /**
  * @brief   Maximum timeframe that can be slept in system ticks.
  */
-#define AOS_THD_MAX_SLEEP_ST    TIME_MAXIMUM
+#define AOS_THD_MAX_SLEEP_ST    TIME_MAX_INTERVAL
 
 /**
  * @brief   Maximum timeframe that can be slept in seconds.
  */
-#define AOS_THD_MAX_SLEEP_S     (ST2S(AOS_THD_MAX_SLEEP_ST) - 1)
+#define AOS_THD_MAX_SLEEP_S     (TIME_I2S(AOS_THD_MAX_SLEEP_ST) - 1)
 
 /**
  * @brief   Maximum timeframe that can be slept in milliseconds.
  */
-#define AOS_THD_MAX_SLEEP_MS    (ST2MS(AOS_THD_MAX_SLEEP_ST) - 1)
+#define AOS_THD_MAX_SLEEP_MS    (TIME_I2MS(AOS_THD_MAX_SLEEP_ST) - 1)
 
 /**
  * @brief   Maximum timeframe that can be slept in microseconds.
  */
-#define AOS_THD_MAX_SLEEP_US    (ST2US(AOS_THD_MAX_SLEEP_ST) - 1)
+#define AOS_THD_MAX_SLEEP_US    (TIME_I2US(AOS_THD_MAX_SLEEP_ST) - 1)
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/os/core/inc/aos_timer.h b/os/core/inc/aos_timer.h
index 12a49e1..d784b34 100644
--- a/os/core/inc/aos_timer.h
+++ b/os/core/inc/aos_timer.h
@@ -25,22 +25,22 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /**
  * @brief   Maximum timer interval that can be set in system ticks.
  */
-#define AOS_TIMER_MAX_INTERVAL_ST     TIME_MAXIMUM
+#define AOS_TIMER_MAX_INTERVAL_ST     TIME_MAX_INTERVAL
 
 /**
  * @brief   Maximum timer interval that can be set in seconds.
  */
-#define AOS_TIMER_MAX_INTERVAL_S      (ST2S(AOS_TIMER_MAX_INTERVAL_ST) - 1)
+#define AOS_TIMER_MAX_INTERVAL_S      (TIME_I2S(AOS_TIMER_MAX_INTERVAL_ST) - 1)
 
 /**
  * @brief   Maximum timer interval that can be set in milliseconds.
  */
-#define AOS_TIMER_MAX_INTERVAL_MS     (ST2MS(AOS_TIMER_MAX_INTERVAL_ST) - 1)
+#define AOS_TIMER_MAX_INTERVAL_MS     (TIME_I2MS(AOS_TIMER_MAX_INTERVAL_ST) - 1)
 
 /**
  * @brief   Maximum timer interval that can be set in microseconds.
  */
-#define AOS_TIMER_MAX_INTERVAL_US     (ST2US(AOS_TIMER_MAX_INTERVAL_ST) - 1)
+#define AOS_TIMER_MAX_INTERVAL_US     (TIME_I2US(AOS_TIMER_MAX_INTERVAL_ST) - 1)
 
 /**
  * @brief   Timer stucture.
diff --git a/os/core/src/aos_interrupts.c b/os/core/src/aos_interrupts.c
new file mode 100644
index 0000000..d5ee819
--- /dev/null
+++ b/os/core/src/aos_interrupts.c
@@ -0,0 +1,80 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2018  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <aos_interrupts.h>
+
+/**
+ * @brief   Initializes the interrupt driver.
+ *
+ * @param[out]  intd            Interrupt driver object.
+ * @param[in]   interrupt_cfg   Interrupt configuration to be used to initialize the driver.
+ */
+void aosIntDriverInit(aos_interrupt_driver_t *intd, aos_interrupt_cfg_t *interrupt_cfg) {
+  intd->interrupts = interrupt_cfg;
+}
+
+/**
+ * @brief   Starts the interrupt system by setting the pad callbacks and starting the pad events.
+ *
+ * @param[in]   intd    Interrupt driver with an interrupt configuration that specifies which interrupts to start.
+ */
+void aosIntDriverStart(aos_interrupt_driver_t *intd) {
+  irqInit();
+  for (uint8_t i = 0; i < intd->len; i++) {
+    chSysLock();
+    palSetPadCallbackI(intd->interrupts[i].port, intd->interrupts[i].pad, intd->interrupts[i].cb, &intd->interrupts[i].cb_arg);
+    if (intd->interrupts[i].flags & AOS_INTERRUPT_AUTOSTART) {
+      palEnablePadEventI(intd->interrupts[i].port, intd->interrupts[i].pad, intd->interrupts[i].eventmode);
+    }
+    chSysUnlock();
+  }
+}
+
+/**
+ * @brief   Stops the interrupt system.
+ *
+ * @param[in]   intd   All events associated with this driver will be disabled.
+ */
+void aosIntDriverStop(aos_interrupt_driver_t *intd) {
+  for (uint8_t i = 0; i < intd->len; i++) {
+    palDisablePadEvent(intd->interrupts[i].port, intd->interrupts[i].pad);
+  }
+  irqDeinit();
+}
+
+/**
+ * @brief   Enables the events on a specified channel.
+ *
+ * @param[in]   intd    Interrupt driver object.
+ * @param[in]   channel Channel of the interrupt to enable.
+ */
+void aosIntEnable(aos_interrupt_driver_t *intd, uint8_t channel) {
+  channel -= 1;
+  palEnablePadEvent(intd->interrupts[channel].port, intd->interrupts[channel].pad, intd->interrupts[channel].eventmode);
+}
+
+/**
+ * @brief   Disables the events on a specified channel.
+ *
+ * @param[in]   intd    Interrupt driver object.
+ * @param[in]   channel Channel of the interrupt to disable.
+ */
+void aosIntDisable(aos_interrupt_driver_t *intd, uint8_t channel) {
+  channel -= 1;
+  palDisablePadEvent(intd->interrupts[channel].port, intd->interrupts[channel].pad);
+}
diff --git a/os/core/src/aos_iostream.c b/os/core/src/aos_iostream.c
index 8cc5b8f..dfbbd18 100644
--- a/os/core/src/aos_iostream.c
+++ b/os/core/src/aos_iostream.c
@@ -121,6 +121,7 @@ static size_t _channelreadt(void *instance, uint8_t *bp, size_t n, systime_t tim
  * @brief   Virtual methods table for all AosIOChannel objects.
  */
 static const struct AosIOChannelVMT _channelvmt = {
+  (size_t) 0,
   _channelwrite,
   _channelread,
   _channelput,
@@ -200,6 +201,7 @@ static msg_t _streamget(void *instance)
  * @brief   Virtual methods table for all AosIOStream objects.
  */
 static const struct AosIOStreamVMT _streamvmt = {
+  (size_t) 0,
   _streamwrite,
   _stremread,
   _streamput,
